<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!--<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">-->

<!--
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed materials - Property of IBM
* Tivoli Presentation Services
*
* (C) Copyright IBM Corp. 2003
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with
* IBM Corp.
************************************************************ {COPYRIGHT-END} ****/
-->
<%@taglib prefix="wcl" uri="WEB-INF/WCLTagLib.tld"%>
<%@taglib prefix="hmc" uri="/WEB-INF/hmc.tld"%>
<%@taglib prefix="c" uri="http://java.sun.com/jstl/core"%>
<%@taglib prefix="fmt" uri="http://java.sun.com/jstl/fmt"%>

<%@page contentType="text/html;charset=UTF-8" 
		language="java"
		import="com.ibm.hwmca.ui.bonsai.status.*,
                com.ibm.hwmca.ui.bonsai.servlet.*,
                com.ibm.hwmca.ui.bonsai.servlet.util.*,
                com.ibm.hwmca.ui.bonsai.earth.*,
                com.ibm.hwmca.ui.bonsai.util.*,
                com.ibm.hwmca.fw.servlet.util.*,
                com.ibm.hwmca.fw.util.*,
                java.util.*" %>

<%!
    LocalizableText title = new LocalizableText("com/ibm/hwmca/ui/bonsai/res/text",
                                                "status.overview.title");
%>

<HTML xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<!-- ===========================================================================
  This JSP is a view.  That is, the WclFacade and all data is defined inside a
  controller Servlet.
  ========================================================================== -->
<wcl:Foundation
	objectScope="session"
    wclFacadeScope="<%= HMCSession.getHMCSession(session).getHMCCustomScope().getScopeName() %>"
    wclFacadeScopeId="<%= ControllerServlet.FACADE_ID_ATTRIBUTE %>"
    pageName="statusoverviewpage">

<HEAD>

<META http-equiv="Content-Type" content="text/html;CHARSET=UTF-8"/>

<LINK href="/css/ui/bonsai/statusoverview.css" rel="stylesheet" type="text/css"/>

<%
    HMCSession hmcSession = HMCSession.getHMCSession(session);
    UserObject userObj = UserObject.getUserObject(hmcSession);

    // build the style string to set for the body
    Map styles = BonsaiTreeManager.getBonsaiTreeManager().getTreeNode(userObj.getTreeSelection()).getWorkareaStyles();
    StringBuffer styleString = new StringBuffer();
    String property = null;
    for (Iterator i = styles.keySet().iterator(); i.hasNext(); )
    {
        property = (String)i.next();
        styleString.append(property);
        styleString.append(":");
        styleString.append((String)styles.get(property));
        styleString.append(";");
    }

    // if this is our first pass through here for the requesting user, create the model
    if (hmcSession.getSessionAttribute("StatusOverviewModel") == null)
    {
        StatusOverviewModel model = new StatusOverviewModel("/ui/bonsai/statusoverview.jsp", userObj);
        StatusMonitorManager statusManager = userObj.getStatusMonitorManager();
        statusManager.addStatusMonitorPropertyListener(model);
        statusManager.getEventQueue().addEventQueueListener(model);
        hmcSession.setSessionAttribute("StatusOverviewModel", model);
    }
%>

</HEAD>

<BODY style="<%= styleString.toString() %>">

<wcl:WTitledLayout objectScopeId="statusOverviewTitle" title="<%= title.toString(request.getLocale()) %>"></wcl:WTitledLayout>

<DIV class="monitor_table">

<%
    StatusOverviewModel model = (StatusOverviewModel)(HMCSession.getHMCSession(session).getSessionAttribute("StatusOverviewModel"));
    StatusMonitorBean bean = null;
    boolean status = false;
    String url = null;
    String urlTarget = null;
    for (Iterator i = model.getBeans().iterator(); i.hasNext(); )
    {
        bean = (StatusMonitorBean)i.next();
        status = bean.isStatusAcceptable();
        url = bean.getUrl();
        urlTarget = bean.getUrlTarget();
%>
    <DIV class="<%= status ? "monitor_entry_good" : "monitor_entry_bad" %>">

        <DIV class="monitor_title_area">
            <IMG src="<%= bean.getStatusImage() %>" height="16" width="16"/>
            <IMG src="/res<%= bean.getImage() %>"/>
<%      if (url == null) {%>
            <SPAN class="monitor_title_text"><%= bean.getName() %></SPAN>
<%      } else {%>
            <A class="monitor_title_text" href="<%= url %>"<%= (urlTarget == null) ? "" : " target=\"" + urlTarget + "\"" %>><%= bean.getName() %></A>
<%      }%>
        </DIV>

        <DIV class="monitor_details_area">
<%
        String[] lines = bean.getDetails();
        for (int j = 0; j < lines.length; j++)
        {
%>
            <P class="monitor_details_text"><%= lines[j] %></P>
<%
        }
%>
        </DIV>

        <BR style="clear: both"/>

    </DIV>

<%
        if (i.hasNext())
        {
%>
    <DIV class="monitor_entry_spacer"></DIV>
<%
        }
    }
%>

</DIV>

</BODY>

</wcl:Foundation>

</HTML>
